% D'aprs JAN VANDENHEEDE, 07/03/2003.
% Ce programme en Prolog calcule tous les hexacordes chromatiques (dont les extrmes sont donc
%  distance d'une quarte juste) dont les intervalles entre notes successives comportent tous
% les intervalles plus petits que le triton.
% Les 24 rsultats sont affichs.  Les chiffres de 0  5 reprsentent les 6 notes chromatiques
% adjacentes. Les rsultats qui se trouvent en relation de renversement et/ou de rcurrence,
% sont  chaque fois groups sur 2 lignes conscutives. Seulement un reprsentant de ces 4 est
%  chaque fois gard en mmoire (dans la rgle Prolog nomme solution).

% Utilise YAP Prolog (Yet Another Prolog), Universit de Porto
% cf. http://www.dcc.fc.up.pt/~vsc/Yap/downloads.html
% /Applications/ApplisDLO/30-Langages/YAP_Prolog/usr/local/bin/yap

/*
1- La commande yap doit tre dans le path de l'utilisateur.
2- Un fichier startup doit dj tre dans le directory de lancement
3- Dans une fentre UNIX situe dans ce directory, faire les commandes >>>> :
>>>>	MacBookPro-dlo.1] yap
		% Restoring file /Users/dlo/startup
		YAP version Yap-5.1.1
>>>>   			?- reconsult('/Volumes/DD/1DLO/cl.d/ped.d/ped.01a.yap') .
 		% reconsulting /Volumes/DD/1DLO/cl.d/ped.d/ped.01a.yap...
		% reconsulted /Volumes/DD/1DLO/cl.d/ped.d/ped.01a.yap in module user, 28 msec 8192 bytes
		yes
>>>>   			?- chromatic_all_interval_6_note_groups .
*		[0,5,1,4,2,3] [3,2,4,1,5,0]
*		[5,0,4,1,3,2] [2,3,1,4,0,5]
*		...
*		solution([0,5,1,4,2,3]).
*		...
		yes
>>>>   			?- ^C
>>>>			Action (h for help): e
		e
	MacBookPro-dlo.2] ...
3- Les solutions sont les lignes marques *
*/

:- abolish(solution/1) .
:- dynamic(solution/1) .

pitch(0) .
pitch(1) .
pitch(2) .
pitch(3) .
pitch(4) .
pitch(5) .

chromatic_all_interval_6_note_groups :- 
	different([X0, X1, X2, X3, X4, X5]),
	different([I1, I2, I3, I4, I5]),
	pitch(X0),
	pitch(X1),
	I1 is abs(X1 - X0),
	pitch(X2),
	I2 is abs(X2 - X1),
	pitch(X3),
	I3 is abs(X3 - X2),
	pitch(X4),
	I4 is abs(X4 - X3),
	pitch(X5),
	I5 is abs(X5 - X4),
	not(solution([X0, X1, X2, X3, X4, X5])),
	not(solution([X5, X4, X3, X2, X1, X0])),
	slsub(5, [X0, X1, X2, X3, X4, X5], [Y0, Y1, Y2, Y3, Y4, Y5]),
	not(solution([Y0, Y1, Y2, Y3, Y4, Y5])),
	not(solution([Y5, Y4, Y3, Y2, Y1, Y0])),
	assertz(solution([X0, X1, X2, X3, X4, X5])),
	write([X0, X1, X2, X3, X4, X5]), write(' '), write([X5, X4, X3, X2, X1, X0]), nl,
	write([Y0, Y1, Y2, Y3, Y4, Y5]), write(' '), write([Y5, Y4, Y3, Y2, Y1, Y0]), nl, nl,
	fail .
chromatic_all_interval_6_note_groups :- listing(solution), ! .

different([H1]) :- ! .
different([H1, H2 | T]) :- 
	different2([H1, H2 | T]),
	different([H2 | T]) .
different2([H1]) :- ! .
different2([H1, H2 | T]) :- 
	dif(H1, H2),
	different2([H1 | T]) .

slsub(S, [], []) :- ! .
slsub(S, [H | T], [H2 | T2]) :- H2 is S - H, slsub(S, T, T2) .

