/*
% D'aprs JAN VANDENHEEDE, 07/03/2003.
% Ce programme en Prolog calcule tous les hexacordes chromatiques
% (dont les extrmes sont donc  distance d'une quarte juste) dont les
% intervalles entre notes successives comportent tous les intervalles
% plus petits que le triton.

% Utilise YAP Prolog (Yet Another Prolog), Universit de Porto
% cf. http://www.dcc.fc.up.pt/~vsc/Yap/downloads.html
% /Applications/ApplisDLO/30-Langages/YAP_Prolog/usr/local/bin/yap

/*
1- La commande yap doit tre dans le path de l'utilisateur.
2- Un fichier startup doit dj tre dans le directory de lancement
3- Dans une fentre UNIX situe dans ce directory, faire les commandes >>>> :
>>>>	MacBookPro-dlo.1] yap
		% Restoring file /Users/dlo/startup
		YAP version Yap-5.1.1
>>>>   			?- reconsult('/Volumes/DD/1DLO/cl.d/ped.d/ped.01b.yap') .
 		% reconsulting /Volumes/DD/1DLO/cl.d/ped.d/ped.01b.yap...
		% reconsulted /Volumes/DD/1DLO/cl.d/ped.d/ped.01b.yap in module user, 21 msec 4096 bytes
		yes
>>>>   			?- chromatic_all_interval_hexachord([X0, X1, X2, X3, X4, X5]) .
*		X0 = 0,
*		X1 = 5,
*		X2 = 1,
*		X3 = 4,
*		X4 = 2
* >>>>		X5 = 3 ? ;
*		X0 = 1,
*		X1 = 3,
*		X2 = 2,
*		X3 = 5,
*		X4 = 0
* >>>>		X5 = 4 ? ; ...
*		...
* >>>>		... ? ^C (ou continuer jusqu' puisement des 24 solutions...)
>>>>			Action (h for help): e
		e
	MacBookPro-dlo.2] ...
3- Une seule solution est imprime  la	 fois ( partir de la 1re de la version ped.01a.yap) dans les lignes marques *
*/

pitch(0) .
pitch(1) .
pitch(2) .
pitch(3) .
pitch(4) .
pitch(5) .

chromatic_all_interval_hexachord([X0, X1, X2, X3, X4, X5]) :-
	different([X0, X1, X2, X3, X4, X5]),
	different([I1, I2, I3, I4, I5]),
	pitch(X0),
	pitch(X1),
	I1 is abs(X1 - X0),
	pitch(X2),
	I2 is abs(X2 - X1),
	pitch(X3),
	I3 is abs(X3 - X2),
	pitch(X4),
	I4 is abs(X4 - X3),
	pitch(X5),
	I5 is abs(X5 - X4).

different([H1]) :- ! .
different([H1, H2 | T]) :- 
	different2([H1, H2 | T]),
	different([H2 | T]) .
different2([H1]) :- ! .
different2([H1, H2 | T]) :- 
	dif(H1, H2),
	different2([H1 | T]) .
