;;; Pour la dmonstration de carrs magiques : vrification et affichage des
;;; sommes
;$$ Zur Demonstration der magischen Quadrate: Prfung und Ausgabe der Summen
;$$                                                                   [d..H.B.]
;++ To Demonstrate Magic Squares: Check and Printout of the Sums

;;; Fonctions carre et test : cf. ped.16.3
;$$ carre- und test-Funktion: Vgl. ped.16.3
;++ Functions carre and test: cf. ped.16.3

;;   Charger les fichiers ped.08 et ped.16.3.
;$   Lade die Dateien ped.08 und ped.16.3.
;+   Load files ped.08 and ped.16.3.

;; <1> Definition des Wurzel-Paths
(setq common-lisp::*wurzel-path*
  (merge-pathnames
    (make-pathname :directory (pathname-directory *load-truename*)) "*"))
;; <2> Zustzliche Aufladung(en)
(dolist (lefic '(
                 "ped.08.lisp"
                 "ped.16.3.lisp"
                 ))
  (load (setq lefic (merge-pathnames lefic common-lisp::*wurzel-path*)))
  (format t "~&;; Geladen ~S~%" lefic))

;;   Les deux fonctions montre et teste servent d'interfaces  carre et test
;; respectivement. Ces deux dernires proviennent d'un fichier du Chapitre 16 du
;; cours : ped.16.3.
;$   Die beiden Funktionen montre und teste werden als Interface zu carre
;$ respektive test benutzt. Diese letzteren beiden sind in einer Datei von
;$ Kapitel 16 der Vorlesungen definiert: ped.16.3.
;+   The two functions montre and teste are used as interfaces to carre and test
;+ respectively. These two latter are defined in a file from Chapter 16 of the
;+ lectures: ped.16.3.

;;   Pour imprimer une liste de listes sous forme d'un pav <n> * <n> de
;; nombres.
;$   Ausgeben einer Liste von Listen als Block mit <n> x <n> Zahlen.
;+   To print a list of lists as a block of <n> * <n> numbers.
;- Exemples : / Beispiele: / Examples:
;-    (montre (carre3 5 -1 -3))
;-    (montre '((4 9 2) (3 5 7) (8 1 6)))

(defun montre (carrelili)
  (carre (make-array (list (list-length carrelili)
                           (list-length (car carrelili)))
                     :initial-contents carrelili)))

;;   Pour vrifier les sommes des lignes, colonnes et diagonales d'une liste de
;; listes.
;$   berprfen der Summen der Zeilen, Spalten und Diagonalen einer Liste von
;$ Listen.
;+   To check the sums of the lines, columns and diagonals of a list of lists.
;- Exemples : / Beispiele: / Examples:
;-    (teste (carre2 10 5))
;-    (teste '((10 5 15) (15 10 5) (5 15 10)))
;; N.B. : la fonction test vrifie les sommes de toutes les diagonales --  y
;; inclues les diagonales brises, significatives pour des carrs hyper-magiques
;; (cf. fichier ped.16.3). Dans les carrs magiques ordinaires, seulent comptent
;; les deux diagonales principales -- les premires des deux groupes vrifis
;; par la fonction.
;$ N.B.: Die test-Funktion prft die Summe aller Diagonalen -- inklusive der
;$ gebrochenen Diagonalen, welche in einem hypermagischen Quadrat wichtig sind
;$ (Vgl. Datei ped.16.3). In einem gewhnlichen magischen Quadrat werden nur
;$ die Hauptdiagonalen in Betracht gezogen -- die erste der beiden von der
;$ Funktion geprften Gruppen.
;+ N.B.: the test function checks the sums of all diagonals--included the broken
;+ diagonals which are significant in hypermagic squares (cf. ped.16.3 file). In
;+ ordinary magic squares, only the main diagonals are taken into account--the
;+ first of the two groups checked by the function.

(defun teste (carrelili)
  (test (make-array (list (list-length carrelili)
                          (list-length (car carrelili)))
                    :initial-contents carrelili)))

;;   Exemple d'valuations groupes :
;$   Beispiel kombinierter Evaluation:
;+   Example of combined evaluations:
;-    (carre (teste '((4 9 2) (3 5 7) (8 1 6))))
;;       => application de teste suivie de l'impression en pav par carre
;$       => Berechnung durch teste gefolgt von der Ausgabe als Block durch carre
;+       => computations by teste followed by block printout by carre
