;;   Pour obtenir la table de vrit de la proposition logique <fonc>.
;$   Um die Wahrheitstabelle fr eine logische Behauptung <fonc> zu erhalten.
;$                                                                    [d..H.B.]
;+   To obtain the truth table of the logical proposition <fonc>.
;- Exemple : / Beispiel: / Example:
;- (tv implic) =>
;-        T <=  (IMPLIC  NIL NIL)
;-        T <=  (IMPLIC  NIL   T)
;-      NIL <=  (IMPLIC    T NIL)
;-        T <=  (IMPLIC    T   T)
;-     OK

(defmacro tv (fonc &aux p q)
  (if (member fonc '(tautot1 contra1 not))
    (progn
      (format t "~4@A <=  (~A ~4@A)~%"
              (eval (cons fonc (list p))) fonc p)
      (format t "~4@A <=  (~A ~4@A)~%"
              (eval (cons fonc (list (setq p (not p))))) fonc p))
  (progn
  (format t "~4@A <=  (~A ~4@A~4@A)~%"
          (eval (cons fonc (list p               q               ))) fonc p q)
  (format t "~4@A <=  (~A ~4@A~4@A)~%"
          (eval (cons fonc (list p               (setq q (not q))))) fonc p q)
  (format t "~4@A <=  (~A ~4@A~4@A)~%"
          (eval (cons fonc (list (setq p (not p))(setq q (not q))))) fonc p q)
  (format t "~4@A <=  (~A ~4@A~4@A)~%"
          (eval (cons fonc (list p               (setq q (not q))))) fonc p q)))
  '(quote ok))
  