;; <1> Definition des Wurzel-Paths
(setq common-lisp::*wurzel-path*
  (merge-pathnames
    (make-pathname :directory (pathname-directory *load-truename*)) "*"))
;; <2> Zustzliche Aufladung(en)
(dolist (lefic '(
                 "ped.12.lisp"
                 "ped.16.3a.lisp"
                 ))
  (load (setq lefic (merge-pathnames lefic common-lisp::*wurzel-path*)))
  (format t "~&;; Geladen ~S~%" lefic))
;===============================================================================
;;; 16.3b --> VECTEURS ET TABLEAUX, exemple supplmentaire de permutations
;$$ 16.3b --> VEKTOREN UND ARRAYS, zustzliches Permutationsbeispiel
;++ 16.3b --> VECTORS AND ARRAYS, extra permutation example
;===============================================================================

;--                            Jean Meschinot
;--                   Litanies de la Vierge  (1461-1464)

;-               D'honneur sentier, confort sr et parfait,             A
;-               Rubis chri, saphir trs prcieux,                     B
;-               Coeur doux et cher, support bon en tout fait,          A
;-               Infini prix, plaisir mlodieux,                        B
;-               jouis ris, souvenir gracieux,                         B
;-               Dame de sens, mre de Dieu trs nette,                 C
;-               Appuis rassis, dsir humble joyeux,                    B
;-               M'me dfends, trs chre pucelette.                   C

;; << [...] ds le XVe sicle, le grand rhtoriqueur Jean Meschinot (ca. 1420-
;; 1491) compose ses  Litanies de la Vierge  (1461-1464), un pome
;; combinatoire sous-titr
;;            Oraison qui peut se dire par huit ou seize vers,
;;                   tant en rtrogradant que autrement 
;; Il s'agit d'un ensemble de 8 vers qui possdent des rimes intrieures, de
;; sorte qu'on peut en extraire d'autres litanies correctement rimes. Il est
;; possible, par ce simple procd, d'obtenir, d'aprs Bernard Magn, 43 008
;; litanies diffrentes  partir de ce pome de 8 vers ! [...]
;;   On peut permuter les vers qui riment ensemble (par exemple le 1er et le
;; 3e). Les vers tant rtrograd[abl]es, on peut galement les lire  l'envers :
;;    - par ex., le 1er vers peut devenir
;$ << [...] bereits im XVten Jahrhundert hat der groe Rhetoriker Jean Meschinot
;$ (ca. 1420-1491) sein kombinatorisches Gedicht  Litanei an die Jungfrau  
;$ (1461-1464) verfasst, das den Untertitel trgt
;$       Gebet, das in acht oder sechzehn Versen vorgetragen werden kann,
;$                  rckwrts ebenso gut wie anderweitig 
;$ Es besteht aus einer Gruppe von acht Versen, die Binnenreime enthalten,
;$ sodass die Entfernung anderer richtig gereimter Litaneien mglich ist.
;$ Bernard Magn zufolge ermglicht dieser einfache Prozess 43 008 verschiedene
;$ Litaneien aus diesem achtversigem Gedicht zu erlangen! [...]
;$   Verse, die sich reimen, knnen permutiert werden (beispielsweise das erste
;$ und dritte). Da sie umkehrbar sind, knnen sie auch rckwrts gelesen werden:
;$    - bspw. kann aus dem ersten Vers werden
;+ << [...] as early as the XVth Century, the great rhetorician Jean Meschinot
;+ (ca. 1420-1491) composed his  Litanies for the Virgin  (1461-1464), a
;+ combinatorial poem subtitled
;+            Prayer which can be recited in eight or sixteen lines,
;+                      in reverse as well as otherwise 
;+ It consists in a set of eight lines containing internal rhymes, such that the
;+ extraction of other correctly rhymed litanies is possible. According to
;+ Bernard Magn, this simple process allows to obtain 43 008 different litanies
;+ from this eight line poem! [...]
;+   Rhyming lines can be permuted (for instance the first and the third). Being
;+ reversible, the lines can also be read backwards:
;+    - eg. the first line can become
;-         Parfait et sr confort, sentier d'honneur, 
;;    - parfois en groupant plusieurs mots, le 2e vers dev[enant] alors
;$    - manchmal werden einige Worte umgruppiert, sodass aus dem zweiten Vers
;$      wird
;+    - sometimes grouping some words, the second line thus becoming
;-         Trs prcieux saphir, chri rubis, 
;; [...] Ces deux procds, permutation et [rtrogradation], peuvent se
;; combiner. On peut mme les combiner  l'intrieur de chaque vers car ceux-ci
;; sont composs de 2 hmistiches indpendants, le 1er de 4 [pieds], le second
;; de 6.
;;    Jean Meschinot, en indiquant qu'on peut lire 16 vers, invite  sparer ces
;; deux groupes d'hmistiches pour obtenir un pome de 16 vers [...]. Les
;; permutations et [rtrogradation] peuvent galement se produire dans cet
;; ensemble. >>
;$ [...] Diese beiden Prozesse, Permutation und Umkehrung, knnen kombiniert
;$ werden. Sie knnen sogar innerhalb eines Verses kombiniert werden, weil sie
;$ aus zwei unabhngigen Halbversen gebildet sind, der erste aus vier Silben,
;$ der zweite aus sechs.
;$    Angenommen man kann sechzehn Verse lesen, dann erffnet Jean Meschinot die
;$ Mglichkeit diese beiden Gruppen von Halbversen zu separieren um einen
;$ sechzehn-zeiligen Strophe zu erhalten. [...] Permutationen und Umkehrungen
;$ knnen auch auf auf diese Menge angewendet werden. >>
;+ [...] These two processes, permutation and reversal, can be combined. They
;+ can even be combined inside each line, since these are composed of two
;+ independent hemistiches, the first of four syllables, the second of six.
;+    Indicating one can read sixteen lines, Jean Meschinot opens the
;+ possibility of separating these two groups of hemistiches to obtain a sixteen
;+ line verse [...]. Permutations and reversals can also be applied on this
;+ set. >>
;- [www.olats.org/livresetudes/basiques/litteraturenumerique/10_basiquesLN.php].
;- Cf. aussi / Vgl. auch / See also
;-    - MAGN Bernard,  Les prcurseurs : Jean Meschinot , Machines  crire.
;-      Paris : Gallimard, 1999
;-    - fr.wikipedia.org/wiki/Jean_Meschinot
;; N.B.: la sparation du matriau original en seize vers n'est pas implmente
;; ici.
;$ N.B.: die Aufteilung des ursprnglichen Materials in sechzehn Versen ist hier
;$ nicht implementiert.
;+ N.B.: the separation of the original material into sixteen lines is not
;+ implemented here.

;; Table contenant le matriau original de Jean Meschinot
;$ Tabelle, welche das ursprngliche Material von Jean Meschinot enthlt
;+ Table containing the original material of Jean Meschinot

;;   Le nombre de vers et/ou d'"hemistiches" (plus proprement appels "segments"
;; s'il y en avait plus de deux...) sont en principe modifiables, pour ce qui
;; concerne le strict fonctionnement des fonctions compose et imprime
;; ci-dessous. Les tables techniques complmentaires suivantes devraient
;; cependant tre manuellement adaptes dans ce cas.
;;  Pour afficher le pome original de Jean Meschinot, faire
;$   Die Anzahl der Verse und/oder Halbversen (besser "Abschnitte" genannt, wenn
;$ es mehr als zwei sind...) ist prinzipiell vernderbar, sofern auf die genaue
;$ Arbeitsweise der compose und imprime Funktionen unten Bezug genommen wird.
;$ Die folgenden komplementren technischen Tabellen sollten in diesem Fall
;$ allerdings manuell angepasst werden.
;$   Um das ursprngliche Gedicht von Jean Meschinot anzuzeigen, evaluieren Sie 
;+   The number of lines and/or of "hemistiches" (better named "segments" if
;+ there were more than two...) is in principle modifiable, as far as the
;+ strict functioning of the compose and imprime functions below is concerned.
;+ The following complementary technical tables should however be manually
;+ adapted in this case.
;+   To print the original Jean Meschinot poem, evaluate
;-    (imprime Meschinot)

(defparameter Meschinot (make-array '(8 2) :initial-contents
  '(
    (("d'honneur" "sentier"     ) ("confort" "sr" "et" "parfait"  ))
    (("rubis" "chri"           ) ("saphir" "trs prcieux"        ))
    (("coeur" "doux" "et" "cher") ("support" "bon" "en tout" "fait"))
    (("infini" "prix"           ) ("plaisir" "mlodieux"           ))
    (("jouis" "ris"            ) ("souvenir" "gracieux"           ))
    (("Dame" "de sens"          ) ("mre" "de Dieu" "trs nette"   ))
    (("appuis" "rassis"         ) ("dsir" "humble" "joyeux"       ))
    (("m'me" "dfends"         ) ("trs chre" "pucelette"        ))
    ) ))

;;; Tables techniques complmentaires
;$$ Komplementre technische Tabelle
;++ Complementary technical tables

;; Groupes de vers permutables selon les types de rimes
;$ Gruppen von permutablen Versen bezglich der Reimformen
;+ Groups of permutable lines according to rhyme types
(defparameter GrpsVrsPermutbls (make-array 3 :initial-contents
  '(
    (0 2)                                   ;numros des vers de rimes de type A
    (1 3 4 6)                               ;    ...        ...           type B
    (5 7)                                   ;    ...        ...           type C
    ) ))

;; Types de rimes
;$ Reimformen
;+ Rhyme types
(defparameter RimesType (make-array (array-dimension Meschinot 0)
  :initial-contents '(A B A B B C B C)))

;; Utilis pour l'assemblage...
;$ Wird fr die Anordnung benutzt...
;+ Used for the assembly...
(defparameter GroupesRimes (make-array (list (array-dimension Meschinot 0)
                                             (array-dimension Meschinot 1))
                                       :initial-contents
  '(
    (0 0)    ; :=  (  numro-type-de-rime  numro-vers--choisir-dans-groupe   )
    (1 0)
    (0 1)
    (1 1)
    (1 2)
    (2 0)
    (1 3)
    (2 1)) ))

;;   La fonction compose ralise et imprime une variante. L'argument d'appel
;; <materiau> doit tre une table contenant les vers originaux. L'option :struct
;; permet d'imprimer, avant la variante compose, un tableau de sa structure.
;;   Exemples de mise en oeuvre :
;;    - impression de l'original suivi de la variante (avec et sans structure)
;$   Die compose Funktion realisiert und zeigt eine Variante an. Das <materiau>
;$ Argument muss eine Tabelle sein, welche die ursprnglichen Verse enthlt. Die
;$ :struct Option erlaubt es, eine Tabelle seiner Struktur vor der erstellten
;$ Variante anzuzeigen.
;$   Anwendungsbeispiele:
;$    - Anzeige des Originals gefolgt von der Variante (mit und ohne Struktur)
;+   The compose function realizes and prints a variant. The <materiau> calling
;+ argument must be a table containing the original lines. The :struct option
;+ allows to print, before the composed variant, a table of its structure.
;+   Usage examples:
;+    - printout of original followed by variant (with and without structure)
;-        (progn (imprime Meschinot) (compose Meschinot :struct t))
;-        (progn (imprime Meschinot) (compose Meschinot))
;;    - variante seule (avec et sans structure)
;$    - nur die Variante (mit und ohne Struktur)
;+    - variant only (with and without structure)
;-        (compose Meschinot :struct t)
;-        (compose Meschinot)

(defun compose (materiau &key struct)
  (let* ((NbrGrpsVrsPermutbls (array-dimension GrpsVrsPermutbls 0))
         (GrpsVrsPermutes (make-array NbrGrpsVrsPermutbls))
         (StructuRetro (make-array NbrGrpsVrsPermutbls))
         (NbrVers (array-dimension materiau 0))
         (NbrHemi (array-dimension materiau 1))
         (SchVariante (make-array NbrVers))
         (TxtVariante (make-array (list NbrVers NbrHemi)))
         )
    ;prparation de GrpsVrsPermutes = une permutation des vers permutables
    ;(permuter2 : cf. ped.16.3a)
    (dotimes (n NbrGrpsVrsPermutbls)
      (setf (aref GrpsVrsPermutes n) (permuter2 (aref GrpsVrsPermutbls n))))
    ;(print GrpsVrsPermutes)
    ;prparation de StructuRetro = l'application de reverse (T) ou non (NIL) 
    ;0 = vers entier, i.e. les hmistiches entre eux
    ;1 = premier hmistiche
    ;2 = second hmistiche
    ;pour chacun des groupes de vers permuts (faire-liste : cf. ped.12)
    (dotimes (n NbrGrpsVrsPermutbls)
      (setf (aref StructuRetro n) (faire-liste '(zerop (random 2)) 
                                               (1+ 
                                                (array-dimension materiau 1)))))
    ;(print StructuRetro)
    ;(print poeme) ;vide...
    ;composition du schma structurel de la variante
    (dotimes (v NbrVers)
      (setf (aref SchVariante v)
            (list (nth (aref GroupesRimes v 1)
                       (aref GrpsVrsPermutes
                             (aref GroupesRimes v 0)))
                  (aref StructuRetro (aref GroupesRimes v 0)))))
    (when struct (print SchVariante))
    ;composition du texte de la variante
    (dotimes (v NbrVers)
      (let* (lihem
             (lihem (reverse (dotimes (n NbrHemi lihem) (push n lihem))))
             (StrRetr (cadr (aref SchVariante v)))
             (indx 0))
        (when (nth indx StrRetr) (setq lihem (reverse lihem)))
        (let ((indxx -1))
          (dolist (lhem lihem)
            (setf (aref TxtVariante v (incf indxx))
                  (if (nth (incf indx) StrRetr)
                      (reverse (aref materiau (car (aref SchVariante v)) lhem))
                    (aref materiau (car (aref SchVariante v)) lhem)))))
        ;(print lihem)
        ;(print StrRetr)
        ))
    (imprime TxtVariante) ))

;;   Fonction d'impression, avec ponctuation et mise en page appropries.
;$   Anzeige Funktion mit angemesser Interpunktion und Layout.
;+   Printout function, with appropriate punctuation and layout.

(defun imprime (poeme)
  (let ((Nbrvers (array-dimension poeme 0))
        (NbrHemi (array-dimension poeme 1)))
    (labels ((vers (v)
               (format t "~&~15T")
               (dotimes (h NbrHemi)
                 (hemi v h))
               ;(format t "~%"))
               (format t "~70T~A~%" (aref RimesType v)))
             (hemi (v h)
               (let* ((lichaines (aref poeme v h))
                      (lilen (list-length lichaines)))
                 (dotimes (motN lilen)
                   (if (= 0 h motN) (format t "~@(~A~)" (nth motN lichaines))
                     (format t "~A" (nth motN lichaines)))
                   (when (< motN (1- lilen)) (format t " ")))
                 (format t "~A"
                         (if (and (= v (1- NbrVers)) (= h (1- NbrHemi)))
                             "." ","))
                 (when (< h (1- NbrHemi)) (format t " ")))))
      (format t "~&~%")
      (dotimes (vrs NbrVers (progn (format t "~%...AMEN!") t))
        (vers vrs)))))
