;; N.B. : le fichier ped.16.4a doit avoir t charg auparavant.

;;   Illustration du fonctionnement interne de la fonction note-Csound avec les
;; arguments d'appel suivants :
;;    - ascii = #\a
;;    - start = 3.3
;;    - duration = 6.6
;;   Une valuation du let* ci-dessous
;;    - imprime avec dbg les valeurs de ses variables locales
;;    - rend la forme finalement compose (anti-quote anticipation du Chap. 17)
;;   On peut ensuite valuer manuellement les trois funcall internes de cette
;; forme rendue  => supprimer chaque fois l'atome funcall lui-mme.
;;   Le funcall externe quivaut donc  la forme suivante. valuer
;; manuellement :
;-    int.1 int.2                                       int.3                                    st.  dr.  car.
;-    |     |                                           |                                        |    |    |
;-    (UN   '((- (RANDOM 1.0) 0.5) - (RANDOM 3.0) 1.5)  '(-20.0 (440.0 . 1231.0) (-1.0 . -2.0))  3.3  6.6  'A)
;-        => un nonc CSound...

(let* ((carac (read-from-string (string #\a)))   ;caractre ASCII => symbole
 
       (struc (symbol-value carac))              ;accs direct -> structure
       (typde (string (type-of struc)))          ;radical- fonctions d'accs
       (instr (read-from-string                  ;accs -> fonction  appeler
               (concatenate 'string typde "-instrument")))
       (donnC (read-from-string                  ;accs -> donnes communes
               (concatenate 'string typde "-Pcommuns")))
       (donnS (read-from-string                  ;accs -> donnes spcifiques
               (concatenate 'string typde "-Pspecifs"))))

    (dbg carac) (dbg struc) (dbg typde) (dbg instr) (dbg donnC) (dbg donnS)

  `(funcall (funcall ,instr ,struc) (funcall ,donnC ,struc)
                                    (funcall ,donnS ,struc)
                                    3.3          ;start
                                    6.6          ;duration
                                    ,carac))